#
# bncmake.inc
#
# ---------------------------------------------------
# Version Number
# ---------------------------------------------------
BNCVER=0.8
# ---------------------------------------------------
# Install Directory
# ---------------------------------------------------
PREFIX=/usr/local
#PREFIX=/usr/local/icc
#PREFIX=/home/tkouya/local

# ---------------------------------------------------
# GMP, MPFR and MPI Directories
# ---------------------------------------------------
#GMPPREFIX=/usr
GMPPREFIX=/usr/local
#GMPPREFIX=/usr/local/icc
#GMPPREFIX=/usr/local/gmp430
#GMPPREFIX=/home/tkouya/local
#MPFRPREFIX=/usr
MPFRPREFIX=/usr/local
#MPFRPREFIX=/usr/local/icc
#MPFRPREFIX=/usr/local/gmp430
#MPFRPREFIX=/home/tkouya/local
#MPIPREFIX=/usr
#MPIPREFIX=/usr/local/mpich-1.2.5
#MPIPREFIX=/usr/local/mpich-1.2.6
#MPIPREFIX=/usr/local/mpich2-1.0.1
#MPIPREFIX=/usr/local/mpich2-1.0.2p1
#MPIPREFIX=/usr/lib64/openmpi/1.2.7-gcc
#MPIPREFIX=/usr/lib64/openmpi/1.3.2-gcc
#MPIPREFIX=/usr/lib64/openmpi/1.4-gcc
MPIPREFIX=/usr/lib64/openmpi
#MPIPREFIX=/opt/intel/lib/intel64

# ---------------------------------------------------
# Directories
# ---------------------------------------------------
BNCDIR = bnc-$(BNCVER)
SRC = src
ODE = ode
SPARSE = sparse
MM = mm
MPI = mpi
TEST = test
BENCH = bench
DOC = doc
WIN32 = win32
PTHREAD = pthread
CEE = cee
LIBBNC = ../$(SRC)/libbnc.a
LIBODE = ../$(ODE)/libbncode.a
LIBSPARSE = ../$(SPARSE)/libbncsparse.a
LIBMM = ../$(MM)/libbncmm.a
LIBMPI = ../$(MPI)/libmpibnc.a

# ---------------------------------------------------
# ---------------------------------------------------
# Compiler & Linker
# ---------------------------------------------------
#CC = gcc
CC = icc -w
INCICC= -I/opt/intel/include -I/opt/intel/mkl/include
LIBICCDIR = -L/opt/intel/lib/intel64 -L/opt/intel/mkl/lib/intel64
LIBICC = -limf -lirc
#MPICC = mpicc
MPICC = $(CC)
#MPICC = $(MPIPREFIX)/bin/mpicc 
AR = ar rc
CXREF = cxref
# ---------------------------------------------------

# ---------------------------------------------------
# Includes, Definitions and Libraries
# ---------------------------------------------------
# No GMP: Only IEEE754 float/double
# ---------------------------------------------------
#INCLUDES = -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib:/usr/lib:./ $(LIBBNC) -lm
# ---------------------------------------------------
# USE_GMP
# ---------------------------------------------------
#INCLUDES = -DUSE_GMP -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib:/usr/lib:./ $(LIBBNC) /usr/local/lib/libgmp.a -lm
# ---------------------------------------------------
# USE_GMP & USE_MPFR (/usr/local)
# ---------------------------------------------------
#DEFS = -DUSE_GMP -DUSE_MPFR
#INCLUDES = $(DEFS) -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib -L/usr/lib -L./ $(LIBBNC) -lmpfr -lgmp -lm
# ---------------------------------------------------
# USE_GMP & USE_MPFR (home)
# ---------------------------------------------------
DEFS = -DUSE_GMP -DUSE_MPFR
INCLUDES = $(DEFS) -I$(GMPPREFIX)/include -I$(MPFRPREFIX)/include -I$(MPIPREFIX) -I/usr/local/include -I/usr/include -I../ -I./ -I../$(ODE) -I../$(SPARSE) -I../$(MM) $(INCICC)
LIBSDIR = -L$(GMPPREFIX)/lib -L$(MPFRPREFIX)/lib -L$(MPIPREFIX)/lib -L/usr/local/lib -L/usr/lib -L./ $(LIBICCDIR)
LIBS = $(LIBSDIR) $(LIBBNC) -lmpfr -lgmp -lm $(LIBICC)
LIBSODE = $(LIBSDIR) $(LIBBNC) $(LIBODE) -lmpfr -lgmp -lm $(LIBICC)
LIBSSPARSE = $(LIBSDIR) $(LIBBNC) $(LIBSPARSE) -lmpfr -lgmp -lm $(LIBICC)
LIBSMM = $(LIBSDIR) $(LIBMM) $(LIBBNC) $(LIBSPARSE) -lmpfr -lgmp -lm $(LIBICC)
#LIBSMPI = $(LIBSDIR) $(LIBBNC) $(LIBMPI) -lmpfr -lgmp -lm $(LIBICC)
