/* read and write complex matrix and vector */
//#include "bncmm.h"

#ifndef __BNCMM_C_H

#define __BNCMM_C_H

/* double */

// read MatrixMarket format (coodinate or array type only) as vector if possible
CDVector init_cdvector_readMMcoordinate(const char *fname);

// read MatrixMarket format (coodinate type only)
CDMatrix init_cdmatrix_readMMcoordinate(const char *fname);

// writer vector as MatrixMarket format (coodinate type) 
int writeMMcoordinate_cdvector(const char *fname, CDVector dvec);

// writer vector as MatrixMarket format (array type) 
int writeMMarray_cdvector(const char *fname, CDVector dvec);

// writer matrix as MatrixMarket format (coodinate type) 
int writeMMcoordinate_cdmatrix(const char *fname, CDMatrix dmat);

/* MPF */
#ifdef USE_GMP

// read MatrixMarket format (coodinate type only) as vector if possible
CMPFVector _init2_cmpfvector_readMMcoordinate(const char *fname, unsigned long prec);

// read MatrixMarket format (coodinate type only) as vector if possible
CMPFVector init2_cmpfvector_readMMcoordinate(const char *fname, unsigned long prec);

// read MatrixMarket format (coodinate type only) as vector if possible
CMPFVector init_cmpfvector_readMMcoordinate(const char *fname);

// read MatrixMarket format (coodinate type only)
CMPFMatrix _init2_cmpfmatrix_readMMcoordinate(const char *fname, unsigned long prec);

// read MatrixMarket format (coodinate type only)
CMPFMatrix init2_cmpfmatrix_readMMcoordinate(const char *fname, unsigned long prec);

// read MatrixMarket format (coodinate type only)
CMPFMatrix init_cmpfmatrix_readMMcoordinate(const char *fname);

// writer vector as MatrixMarket format (coodinate type) 
int writeMMcoordinate_cmpfvector(const char *fname, CMPFVector dvec);

// writer vector as MatrixMarket format (array type) 
int writeMMarray_cmpfvector(const char *fname, CMPFVector dvec);

// writer matrix as MatrixMarket format (coodinate type) 
int writeMMcoordinate_cmpfmatrix(const char *fname, CMPFMatrix dmat);

#endif

#endif /* End of __BNCMM_C_H */
