/********************************************************************************/
/* Test program for taylor.c                                                    */
/* Copyright (C) 2000-2011 Tomonori Kouya                                       */
/*                                                                              */
/* This program is free software: you can redistribute it and/or modify it      */
/* under the terms of the GNU Lesser General Public License as published by the */
/* Free Software Foundation, either version 3 of the License or any later       */
/* version.                                                                     */
/*                                                                              */
/* This program is distributed in the hope that it will be useful, but WITHOUT  */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or        */
/* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License */
/* for more details.                                                            */
/*                                                                              */
/* You should have received a copy of the GNU Lesser General Public License     */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.        */
/*                                                                              */
/********************************************************************************/
#include <stdio.h>
#include <math.h>

#include "bncode.h"

main()
{
	DTaylor a, b, c, d, test_array[10], test_array2[10];
	DVector y0_v, y_v;
	long int i;

	/* Init */
	a = init_dtaylor();
	b = init2_dtaylor(50);
	c = init_dtaylor();
	d = init_dtaylor();
	for(i = 0; i < 10; i++)
	{
		test_array[i] = init_dtaylor();
		test_array2[i] = init_dtaylor();
	}

	/* Set */
	set_exp_dtaylor(a);
	set_exp_dtaylor(b);
	set_sin_dtaylor(c);
	set_cos_dtaylor(d);

	/* Print */
	printf("a = \n"); print_dtaylor(a);
	printf("b = \n"); print_dtaylor(b);
	printf("c = \n"); print_dtaylor(c);
	printf("d = \n"); print_dtaylor(d);

	/* Arithmetic */
	add_dtaylor(a, c, d);
	printf("c + d = \n"); print_dtaylor(a);

	sub_dtaylor(b, c, d);
	printf("c - d = \n"); print_dtaylor(b);

	smul_dtaylor(b, 100.0, c);
	printf("100 * c = \n"); print_dtaylor(b);

//	sdiv_dtaylor(b, b, 100.0);
//	printf("100 * c / 100 = \n"); print_dtaylor(b);

	diff_dtaylor(b, d);
	printf("Diff(d) = \n"); print_dtaylor(b);

	/* Free */
	free_dtaylor(a);
	free_dtaylor(b);
	free_dtaylor(c);
	free_dtaylor(d);
	for(i = 0; i < 1; i++)
	{
		free_dtaylor(test_array[i]);
		free_dtaylor(test_array2[i]);
	}
}
