/********************************************************************************/
/* test_mpfr.c:                                                                 */
/* Copyright (C) 2003-2011 Tomonori Kouya                                       */
/*                                                                              */
/* This program is free software: you can redistribute it and/or modify it      */
/* under the terms of the GNU Lesser General Public License as published by the */
/* Free Software Foundation, either version 3 of the License or any later       */
/* version.                                                                     */
/*                                                                              */
/* This program is distributed in the hope that it will be useful, but WITHOUT  */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or        */
/* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License */
/* for more details.                                                            */
/*                                                                              */
/* You should have received a copy of the GNU Lesser General Public License     */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.        */
/*                                                                              */
/********************************************************************************/
#include <stdio.h>
#include <math.h>
#include <gmp.h>
#include <mpfr.h>

/* Why doesn't this function exit in mpfr ? */
void mpfr_get_f(mpf_t rop, mpfr_t op, mp_rnd_t rnd)
{
	static char str_tmp[10000], str_tmp0[8192], str_exp_tmp[128];
	static mp_exp_t exp_tmp;
	static int base = 10;

	mpfr_get_str(str_tmp0, &exp_tmp, base, 0, op, rnd);
	sprintf(str_exp_tmp, "@%d", (int)exp_tmp);
	strcat(str_tmp0, str_exp_tmp);
	sprintf(str_tmp, "0.%s", str_tmp0);
	mpf_set_str(rop, str_tmp, base);
}

main()
{
	mpfr_t a;
	mpf_t mpfa;
	double da;

	mpfr_init2(a, 256);
	mpf_init2(mpfa, 256);

	mpfr_set_d(a, 1.1, GMP_RNDN);
//	mpf_set_d(mpfa, (double)1.1);

	//mpfr_set_f(a, mpfa, GMP_RNDN);
	mpfr_get_f(mpfa, a, GMP_RNDN);

	gmp_printf("mpf : %Ff\n", mpfa);
	printf("mpfr :");mpfr_out_str(stdout, 10, 0, a, GMP_RNDN);printf("\n");
	printf("mpfr :");mpfr_print_binary(a);printf("\n");
	printf("mpf  :");mpf_out_str(stdout, 10, 0, mpfa);printf("\n");
	printf("mpf  :");mpf_out_str(stdout, 2, 0, mpfa);printf("\n");

	mpfr_clear(a);
	mpf_clear(mpfa);
}

